export declare const Constants: {
    /**
     * The ms-rest version
     * @const
     * @type {string}
     */
    msRestVersion: string;
    /**
     * Specifies HTTP.
     *
     * @const
     * @type {string}
     */
    HTTP: string;
    /**
     * Specifies HTTPS.
     *
     * @const
     * @type {string}
     */
    HTTPS: string;
    /**
     * Specifies HTTP Proxy.
     *
     * @const
     * @type {string}
     */
    HTTP_PROXY: string;
    /**
     * Specifies HTTPS Proxy.
     *
     * @const
     * @type {string}
     */
    HTTPS_PROXY: string;
    HttpConstants: {
        /**
         * Http Verbs
         *
         * @const
         * @enum {string}
         */
        HttpVerbs: {
            PUT: string;
            GET: string;
            DELETE: string;
            POST: string;
            MERGE: string;
            HEAD: string;
            PATCH: string;
        };
    };
    /**
     * Defines constants for use with HTTP headers.
     */
    HeaderConstants: {
        /**
         * The Authorization header.
         *
         * @const
         * @type {string}
         */
        AUTHORIZATION: string;
        AUTHORIZATION_SCHEME: string;
        /**
         * The UserAgent header.
         *
         * @const
         * @type {string}
         */
        USER_AGENT: string;
    };
};
//# sourceMappingURL=constants.d.ts.map